Subject: Re: [RFC/PATCH] powerpc: Dynamically allocate pacas

From: Michael Neuling <[email-masked]>
Date: Wed, 27 Jan 2010 13:40:44 +1030

> On Fri, 2010-01-22 at 16:19 +1300, Michael Neuling wrote:
> > 
> > In message <39fb8f1aeab9940b86c940b9a5f8e6bd41ec316c.1263368253.git.micha> el@ell
> > erman.id.au> you wrote:
> > > On 64-bit kernels we currently have a 512 byte struct paca_struct for
> > > each cpu (usually just called "the paca"). Currently they are staticall> y
> > > allocated, which means a kernel built for a large number of cpus will
> > > waste a lot of space if it's booted on a machine with few cpus.
> > > 
> > > We can avoid that by only allocating the number of pacas we need at
> > > boot. However this is complicated by the fact that we need to access
> > > the paca before we know how many cpus there are in the system.
> > > 
> > > The solution is to dynamically allocate enough space for NR_CPUS pacas,
> > > but then later in boot when we know how many cpus we have, we free any
> > > unused pacas.
> > > 
> > > Lightly booted on Legacy iSeries & pSeries LPAR.
> > 
> > This is broken on 32bit CPUs.  Dies at compile time with
> > mpc86xx_defconfig.  No paca on 32bit :-(
> 
> Bah, who really uses 32-bit anyway ..

Hehe, that's coming from the guy who tested it on iSeries... :-P

Mikey